//+----------------------------------------------------------------------------+
//|                                                                   OsMA.mq4 |
//|                                             Copyright  2011, JQS aka Joo. |
//|                                           http://www.mql4.com/ru/users/joo |
//+----------------------------------------------------------------------------+
//Indicator of series "NeutronStar"

#property  copyright "Copyright  2011, JQS aka Joo."
#property  link      "http://www.mql4.com/ru/users/joo"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  DeepSkyBlue
#property  indicator_width1  2

//
//---- indicator parameters
extern int Fast        = 12;
extern int Slow        = 26;
extern int Signal      = 9;
extern int FASTmetod   = 0; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
extern int SLOWmetod   = 0; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
extern int MACDmetod   = 0; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
extern int SIGNALmetod = 0; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
//extern int History     = 200;
//

//---- indicator buffers
double     OsmaBuffer    [];
double     MacdBuffer    [];
double     SignalBuffer  [];
double     TempBuffer    [];

//
int init()
{
  IndicatorDigits (8);
  IndicatorBuffers(4);

  //---- drawing settings
  SetIndexStyle    (0,DRAW_HISTOGRAM);
  SetIndexDrawBegin(0,Signal);
  SetIndexLabel    (0,"OsMA");

  //---- indicator buffers mapping
  SetIndexBuffer   (0,OsmaBuffer);
  SetIndexBuffer   (1,MacdBuffer);
  SetIndexBuffer   (2,SignalBuffer);
  SetIndexBuffer   (3,TempBuffer);

  //---- name for DataWindow and indicator subwindow label
  IndicatorShortName("OsMA of <NeutronStar series> ("+Fast+","+Slow+","+Signal+")");

  //---- initialization done
  return(0);
}
//



//
int start()
{
  int limit;
  int counted_bars=IndicatorCounted();

  //----     
  if (counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  //if(limit>History+Fast+Slow+Signal)
  //  limit=History+Fast+Slow+Signal;

  //----------------------------------------------------------------------------

  //----------------------------------------------------------------------------
  for (int i=0; i<limit; i++)
    TempBuffer[i]=(High[i+1]+Low[i+1]+Open[i])/3.0;

  //----  MACD
  for (i=0; i<limit; i++)
    MacdBuffer[i]=Smoothing(TempBuffer,
                            Bars,
                            Fast,
                            0,
                            FASTmetod,
                            i)-
                  Smoothing(TempBuffer,
                            Bars,
                            Slow,
                            0,
                            SLOWmetod,
                            i);

  //----   
  for (i=0; i<limit; i++)
    SignalBuffer[i]=Smoothing(MacdBuffer,
                              Bars,
                              Signal,
                              0,
                              SIGNALmetod,
                              i);
  //if(limit>History)
  //  limit=History;
  //----  
  for (i=0; i<limit; i++)
    OsmaBuffer[i]=MacdBuffer[i]-SignalBuffer[i];
  //----------------------------------------------------------------------------


  //---- done
  return(0);
}
//

//
//0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
double Smoothing(double array[],
                 int    total,
                 int    period,
                 int    ma_shift,
                 int    ma_method,
                 int    shift)
{
  switch (ma_method)
  {
  case 1:
    return(iMAOnArray(array,total,period,ma_shift,MODE_EMA,shift));
    break; 
  case 2:
    return(iMAOnArray(array,total,period,ma_shift,MODE_SMMA,shift));
    break; 
  case 3: 
    return(iMAOnArray(array,total,period,ma_shift,MODE_LWMA,shift));
    break; 
  default: 
    return(iMAOnArray(array,total,period,ma_shift,MODE_SMA,shift));
    break; 
  }
}
//

/*
// Hodrick-Prescott Filter-----------------------------------------------------------------+
void HP(int nobs, int lambda, double& output[])
{
   double a[],b[],c[],H1,H2,H3,H4,H5,HH1,HH2,HH3,HH4,HH5,HB,HC,Z;
   ArrayResize(a,nobs);
   ArrayResize(b,nobs);
   ArrayResize(c,nobs);
   for(int i=0;i<nobs;i++) output[i]=Close[i];
        
   a[0]=1.0+lambda;
   b[0]=-2.0*lambda;
   c[0]=lambda;
   for(i=1;i<nobs-2;i++)
   {
      a[i]=6.0*lambda+1.0;
      b[i]=-4.0*lambda;
      c[i]=lambda;
   }
   a[1]=5.0*lambda+1;
   a[nobs-1]=1.0+lambda;
   a[nobs-2]=5.0*lambda+1.0;
   b[nobs-2]=-2.0*lambda;
   b[nobs-1]=0.0;
   c[nobs-2]=0.0;
   c[nobs-1]=0.0;
   
   //Forward
   for(i=0;i<nobs;i++)
   {
      Z=a[i]-H4*H1-HH5*HH2;
      HB=b[i];
      HH1=H1;
      H1=(HB-H4*H2)/Z;
      b[i]=H1;
      HC=c[i];
      HH2=H2;
      H2=HC/Z;
      c[i]=H2;
      a[i]=(output[i]-HH3*HH5-H3*H4)/Z;
      HH3=H3;
      H3=a[i];
      H4=HB-H5*HH1;
      HH5=H5;
      H5=HC;
   }
   
   //Backward 
   H2=0;
   H1=a[nobs-1];
   output[nobs-1]=H1;
   for(i=nobs-2;i>=0;i--)
   {
      output[i]=a[i]-b[i]*H1-c[i]*H2;
      H2=H1;
      H1=output[i];
   }
}



// Hodrick-Prescott Filter
void HPF(int nobs, int lambda, double& Input[], double& Output[])
{
  double a[],b[],c[],H1=0.0,H2=0.0,H3=0.0,H4=0.0,H5=0.0,HH1=0.0,HH2=0.0,HH3=0.0,HH4=0.0,HH5=0.0,HB=0.0,HC=0.0,Z=0.0;
  ArrayResize(a,nobs);
  ArrayResize(b,nobs);
  ArrayResize(c,nobs);
  int i=0;
  for (i=0;i<nobs;i++) Output[i]=Input[i];

  a[0]=1.0+lambda;
  b[0]=-2.0*lambda;
  c[0]=lambda;
  for (i=1;i<nobs-2;i++)
  {
    a[i]=6.0*lambda+1.0;
    b[i]=-4.0*lambda;
    c[i]=lambda;
  }
  a[1]=5.0*lambda+1;
  a[nobs-1]=1.0+lambda;
  a[nobs-2]=5.0*lambda+1.0;
  b[nobs-2]=-2.0*lambda;
  b[nobs-1]=0.0;
  c[nobs-2]=0.0;
  c[nobs-1]=0.0;

  //Forward
  for (i=0;i<nobs;i++)
  {
    Z=a[i]-H4*H1-HH5*HH2;
    HB=b[i];
    HH1=H1;
    H1=(HB-H4*H2)/Z;
    b[i]=H1;
    HC=c[i];
    HH2=H2;
    H2=HC/Z;
    c[i]=H2;
    a[i]=(Output[i]-HH3*HH5-H3*H4)/Z;
    HH3=H3;
    H3=a[i];
    H4=HB-H5*HH1;
    HH5=H5;
    H5=HC;
  }

  //Backward 
  H2=0;
  H1=a[nobs-1];
  Output[nobs-1]=H1;
  for (i=nobs-2;i>=0;i--)
  {
    Output[i]=a[i]-b[i]*H1-c[i]*H2;
    H2=H1;
    H1=Output[i];
  }
}
//------------------------------------------------------------------------
*/